SystemOrganization addCategory: #'OB-Installer-Base'!

Object subclass: #OBInstaller
	instanceVariableNames: 'hasMonticello'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Installer-Base'!

!OBInstaller class methodsFor: 'installing' stamp: 'cwp 12/5/2004 21:25'!
initialize! !

!OBInstaller class methodsFor: 'installing' stamp: 'cwp 12/5/2004 21:18'!
install
	self new install! !

!OBInstaller methodsFor: 'installing' stamp: 'cwp 10/25/2004 23:09'!
doInstall
	self removeNotifier.
	self hasMonticello
        ifTrue: [self installViaMC]
        ifFalse: [self installViaMczInstaller]
! !

!OBInstaller methodsFor: 'configuration' stamp: 'cwp 1/8/2005 22:22'!
files
	^ #(
		'Bogus-cwp.14.mcz' 
		'BogusExt-cwp.1.mcz' 
		'BogusInfo-cwp.12.mcz' 
		'OmniBrowser-cwp.257.mcz' 
		'OB-Standard-cwp.79.mcz'
	)
! !

!OBInstaller methodsFor: 'preparation' stamp: 'cwp 10/25/2004 22:37'!
fixDependencyBug
	MczInstaller compile: 'versions: aVersionList anySatisfy: aDependencyID
	^ aVersionList anySatisfy: [:version | 
			aDependencyID = (version at: #id)
				or: [self 
						versions: (version at: #ancestors ifAbsent: [^ false]) 
						anySatisfy: aDependencyID]]
'
! !

!OBInstaller methodsFor: 'testing' stamp: 'cwp 10/26/2004 01:46'!
hasMonticello
	^ Smalltalk hasClassNamed: 'MCReader'
! !

!OBInstaller methodsFor: 'installing' stamp: 'cwp 10/25/2004 23:09'!
install
	self shouldInstall ifTrue: [self doInstall]! !

!OBInstaller methodsFor: 'installing' stamp: 'cwp 10/25/2004 23:22'!
installMC
	(SMSqueakMap default packageWithName: 'Monticello') releases last install! !

!OBInstaller methodsFor: 'installing' stamp: 'cwp 10/26/2004 02:41'!
installViaMC
	 | repository versions addRepository |
	versions := OrderedCollection new.
	repository := self repository.
	addRepository := [:v | v workingCopy repositoryGroup addRepository: repository].
	MCRepositoryGroup default addRepository: repository.
	self files do: 
		[:filename | | version |
		version := repository loadVersionFromFileNamed: filename.
		versions add: version.
		version 
			load;
			in: addRepository.
		versions do: [:ea | ea workingCopy modified: false]]
        ! !

!OBInstaller methodsFor: 'installing' stamp: 'cwp 10/25/2004 22:43'!
installViaMczInstaller
	self fixDependencyBug.
	self files do: [:filename | | contents |
		contents := HTTPSocket httpGet: self repositoryUrl, filename.
		MczInstaller installStream: contents readStream.
	]
	  ! !

!OBInstaller methodsFor: 'testing' stamp: 'cwp 10/25/2004 23:27'!
noPreviousVersion
	^ (Smalltalk hasClassNamed: 'OBBrowser') not! !

!OBInstaller methodsFor: 'preparation' stamp: 'cwp 10/25/2004 23:14'!
offerToInstallMC
	| ok |
	ok := self confirm: 'To upgrade OmniBrowser from the installed version,
you must have Monticello installed. Would you like to install it now?'.
	ok ifTrue: [self installMC].
	^ ok! !

!OBInstaller methodsFor: 'preparation' stamp: 'cwp 10/25/2004 22:49'!
removeNotifier
	"Get rid of any OBNotifier instances from earlier versions of OB"
	Smalltalk at: #OBNotifier ifPresent:
		[:notifier | | scn |
		scn := SystemChangeNotifier uniqueInstance.
		notifier allInstances do: [:ea | scn noMoreNotificationsFor: ea]].
! !

!OBInstaller methodsFor: 'accessing' stamp: 'cwp 10/25/2004 22:43'!
repository
	^ MCHttpRepository 
		location: self repositoryUrl 
		user: ''
		password: ''! !

!OBInstaller methodsFor: 'configuration' stamp: 'cwp 10/25/2004 22:39'!
repositoryUrl
	^ 'http://monticello.wiresong.ca/ob/'! !

!OBInstaller methodsFor: 'testing' stamp: 'cwp 10/26/2004 01:47'!
shouldInstall
	^ self noPreviousVersion 
		or: [self hasMonticello]
		or: [self offerToInstallMC]! !

!OBInstaller methodsFor: 'accessing' stamp: 'cwp 10/26/2004 00:54'!
versionName
	^ self files last! !
OBInstaller initialize!
